#!/usr/bin/perl
use DateTime;
use DateTime::Duration;
use DateTime::TimeZone;
use File::Path;
use strict;

my $DIR = "/home/ATS/md110"; 

my $timezone = `date "+%z"`;
my $dt = DateTime->now( time_zone => $timezone );
$dt->subtract( hours => 1 );

my $year = $dt->strftime( "%Y" );
my $month = $dt->strftime( "%m" );
my $day = $dt->strftime( "%d" );
my $hour = $dt->strftime( "%H" );

process_ats();

sub process_ats
{
    print "starting:".localtime()."\n";
    my $log_name = "$year.$month.$day.$hour.log";
    
    system( "$DIR//hour_log $year $month $day $hour $log_name" );
    
    my $log_path = "$DIR/$year/$month";
    #my $hour_log_name = $day."_".$hour;
    
    mkpath( $log_path );
	
    system( "$DIR/convert_log.pl $log_name" );
    
 	system( "/home/BGBillingServer/data_loader.sh -eload=$year-$month-$day-$hour-1");
}