#!/usr/bin/perl
use strict;
use URI;
use Net::FTP;
use FileHandle;
use File::Path; 


my $DIR = "/home/ATS/mx96"; 
#my $DIR = "/home/dimon/projects/mnu/ATS/mx96"; 

check_ftp_logs( "ftp://mx96tarif:N78t5xOI0\@10.225.101.59");
#check_ftp_logs( "ftp://anonymous:anonymous\@gate/pub");

sub check_ftp_logs
{	
    my $uri = new URI( shift );

    die "error in url" unless $uri->scheme && $uri->scheme eq "ftp";
    
    print localtime()."\n";
    my( $s_now, $n_now, $h_now, $d_now, $m_now, $y_now )=localtime();
    $m_now++;
    $y_now-=100;
    
    print "Connect to '".$uri->host."' ... \n";
    my $ftp = new Net::FTP( $uri->host, Port=>$uri->port, Passive=>1, Debug => 0) or die "Cannot connect to $uri->host: $@";

    my $ftp_dir = $uri->path;    
	    
    $ftp->login($uri->user,$uri->password) or die "Cannot login ", $ftp->message;
    $ftp->binary;

    $ftp->cwd( $ftp_dir ) or die("Cannot change working directory ", $ftp->message);
	
    print "reading new files...\n";
    my @list = $ftp->ls();
    M1:
    foreach my $name ( @list )
    {
	if( $name =~ /^(\d{2})(\d{2})(\d{2})(\w{1})(\w{1})\.C35$/ )
	{
	    my $year = $1;
	    my $month = $2;
	    my $day = $3;
	    my $index = $5.$4;
	    
	    # чтобы сегодняшний не исполнялся
	    next M1 if ( $year==$y_now && $month==$m_now && $day==$d_now );

	    my $log_dir = "$DIR/source/20$year/$month/$day";
	    mkpath("$log_dir" ); 

	    my $log_name = "$log_dir/log_$index";

	    if (  -e "$log_name" )
	    {
		#print "file '$log_name' already created. skipping\n";
		next M1;
	    }							

	    my $file_ftp_path = "$ftp_dir/$name";

	    print "Saving '$file_ftp_path' to '$log_name'...\n";
	    $ftp->get( $file_ftp_path, $log_name );
	    print "converting logs dir '$log_dir'...\n";
	    #if (system( "$DIR/convert_log.pl $log_dir > /dev/null" ) )
	    if ( system( "$DIR/convert_log.pl $log_dir" ) )
	    {
		print "FAILED: $? : $!\n";
	    }
	    else
	    {
		print "OK\n";
	    }
	    #print "adding log $year-$month-$day-$hour to loader.. \n."; 
	    #system( "/home/BGBillingServer/data_loader.sh -eload=$year-$month-$day-$hour-3");
	}
    }

    $ftp->quit;
}

print "getting logs Finished\n";
