#!/usr/bin/perl
use strict;
use URI;
use Net::FTP;
use FileHandle;
use File::Path; 


my $DIR = "/home/ATS/si2000"; 

check_ftp_logs( "ftp://mnadmin:mnadmin\@192.168.235.220");

sub check_ftp_logs
{	
    my $uri = new URI( shift );
    

    die "error in url" unless $uri->scheme && $uri->scheme eq "ftp";
	print localtime()."\n";
    print "Connect to ".$uri->host." ... \n";
    my $ftp = new Net::FTP( $uri->host, Port=>$uri->port, Passive=>1, Debug => 0)
	or die "Cannot connect to $uri->host: $@";
    
    my $ftp_path = $uri->path;
    
	    
    $ftp->login($uri->user,$uri->password)
       or die "Cannot login ", $ftp->message;
    $ftp->binary;

    $ftp->cwd( $ftp_path ) || 
	die("Cannot change working directory ", $ftp->message);
	
    print "reading new files...\n";
    my @list = $ftp->ls();
    M1:
    foreach my $name ( @list )
    {
	
		if( $name =~ /^i2222(\d{4})(\d{2})(\d{2})(\d{2})(\d{4,}).ama$/ )
		{

			my $year = $1;
			my $month = $2;
			my $day = $3;
			my $hour = $4;
			my $index = $5;
			
			my $log_path = "$year/$month/$day/$hour";
						
			mkpath("$DIR/source/$log_path" ); 

			my $log_name = "$log_path/log_$index";
				

			if (  -e "$DIR/source/$log_name" )
			{
				#print "File $log_name already created. skipping\n";
				next M1;
			}							
			
			my $file_ftp_path = "$ftp_path/$name";
			my $local_path = "$DIR/source/$log_name";
				
			print "Saving $file_ftp_path to $local_path\n";
			$ftp->get( $file_ftp_path, $local_path );	    
			print "converting log $log_path..\n.";
			if (system( "$DIR/convert_log.pl $log_path > /dev/null" ) )
			{
					print "FAILED\n";
			}
			else
			{
				print "OK\n";
			}
			print "adding  log $year-$month-$day-$hour to loader.. \n."; 
			system( "/home/BGBillingServer/data_loader.sh -eload=$year-$month-$day-$hour-2");
		}
    }


    $ftp->quit;
}

print "getting logs Finished\n";

